100 REMark example routines for use with DISPLAY_CDE
110 REMark written by Dilwyn Jones, June 1997
120 :
1000 DEFine PROCedure FULL_SCREEN (channel)
1010   dw = FLIM_W(#channel) : dh = FLIM_H(#channel)
1020   dx = FLIM_X(#channel) : dy = FLIM_Y(#channel)
1030   WINDOW #channel,dw,dh,dx,dy
1040 END DEFine FULL_SCREEN
1050 :
1060 DEFine PROCedure STORE_A_SCREEN
1070   screen_length = BYTES(#0)*FLIM_H(#0)
1080   area = ALCHP(screen_length)
1090   IF area < 0 THEN PRINT #0,'Unable to reserve memory.' : RETurn
1100   MOVEMEM ADDRESS(#0) TO area, screen_length
1110 END DEFine STORE_A_SCREEN
1120 :
1130 DEFine PROCedure RESTORE_A_SCREEN
1140   IF area > 0 THEN
1150     MOVEMEM area TO ADDRESS(#0), screen_length
1160   END IF
1170   RECHP area
1180 END DEFine RESTORE_A_SCREEN
1190 :
1200 DEFine PROCedure MERGE_SCREEN (filename$)
1210   REMark merges a 32K 512x256 screen onto the top left corner of a larger display
1220   area = ALCHP (32768)
1230   IF area < 0 THEN PRINT #0,'Unable to allocate memory.' : RETurn
1240   LBYTES filename$,area
1250   from_address = area
1260   to_address = ADDRESS(#0)
1270   FOR a = 1 TO 256
1280     MOVEMEM from_address TO to_address,128
1290     from_address = from_address + 128
1300     to_address = to_address + BYTES(#0)
1310   END FOR a
1320   RECHP area : REMark finished with it
1330 END DEFine MERGE_SCREEN
1340 :
1350 DEFine PROCedure FILL_MEM (addr,no_of_bytes,byte_value)
1360   POKE addr,byte_value
1370   MOVEMEM addr TO addr+1,no_of_bytes-1
1380 END DEFine FILL_MEM
1390 :
1400 DEFine FuNction SYSTEM_VALUE (what_offset)
1410   RETurn PEEK(SYS_VAR+what_offset)
1420 END DEFine SYSTEM_VALUE
1430 :
1440 DEFine PROCedure SET_MODE (mode_number)
1450   IF DMODE <> mode_number THEN MODE mode_number
1460 END DEFine SET_MODE
1470 :
1480 DEFine PROCedure IS_THERE_GD2
1490   IF GD2(#0) = 1 THEN
1500     PRINT'Colour drivers available!'
1510   ELSE
1520     PRINT'No colour drivers available.'
1530   END IF
1540 END DEFine IS_THERE_GD2
1550 :
1560 DEFine PROCedure VERSIONS
1570   PRINT 'S*BASIC           : ';VER$
1580   PRINT 'Operating system  : ';OS_VER$
1590   PRINT 'Pointer interface : ';
1600   IF PTR_ENV(#0) THEN
1610     PRINT PTRVER$(#0)
1620     PRINT 'Window manager    : ';WMAVER$(#0)
1630   ELSE
1640     PRINT'None'
1650   END IF
1660 END DEFine VERSIONS
1670 :
1680 DEFine PROCedure IS_THERE_PE
1690   IF PTR_ENV(#0) = 1 THEN
1700     PRINT'Pointer Interface ';
1710     IF WIN_MAN(#0) = 1 THEN PRINT'and Window Manager '; : ELSE PRINT'only ';
1720     PRINT'installed.'
1730   ELSE
1740     PRINT'No pointer environment installed.'
1750   END IF
1760 END DEFine IS_THERE_PE
